//
// Created by kgrug on 23.10.2020.
//

#include "testlib.h"
#include <string>
#include <algorithm>

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = stoi(argv[1]);
    println(n);

    int k1 = stoi(argv[2]);
    int k2 = stoi(argv[3]);

    string taskRegExp, verdictRegExp;
    switch (k1) {
        case 1:
            taskRegExp = "[A]";
            break;
        case 2:
            taskRegExp = "[A-B]";
            break;
        default:
            taskRegExp = "[A-Z]";
            break;
    }
    switch (k2) {
        case 1:
            verdictRegExp = "OK";
            break;
        case 2:
            verdictRegExp = "OK|WA";
            break;
        case 3:
            verdictRegExp = "OK|WA|CE";
            break;
        case 4:
            verdictRegExp = "TL|ML|WA|RE|CE|SV";
            break;
        default:
            verdictRegExp = "OK|TL|ML|WA|RE|CE|SV";
            break;
    }

    vector<pair<int, int>> tmpTimes;

    for (int i = 0; i < n; i++) {
        int h = rnd.next(0, 4);
        int m = rnd.next(0, 59);
        tmpTimes.emplace_back(h, m);
    }

    sort(tmpTimes.begin(), tmpTimes.end());

    for (int i = 0; i < n; i++) {
        int h = tmpTimes[i].first;
        int m = tmpTimes[i].second;

        string hh = (h > 9) ? to_string(h) : "0" + to_string(h);
        string mm = (m > 9) ? to_string(m) : "0" + to_string(m);

        string strTime = hh.append(":").append(mm);

        string task = rnd.next(taskRegExp);

        string verdict = rnd.next(verdictRegExp);

        println(strTime, task, verdict);
    }
}