#include "testlib.h"
#include <set>

const long long MAXN = 200000;
const long long MAXL = 20;

std::set<std::pair<std::pair<int, int>, std::pair<int, int>>> graph;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    long long n = inf.readLong(1ll, MAXN, "n");
    inf.readSpace();
    long long m = inf.readLong(1ll, MAXN, "m");
    inf.readSpace();
    long long k = inf.readLong(0ll, (n - 1) * m + n * (m - 1), "k");
    ensuref(n * m <= MAXN, "square should be less than or equal to 200000");
    inf.readEoln();
    for (int i = 0; i < k; i++) {
        int x1 = inf.readLong(1, n, "x1");
        inf.readSpace();
        int y1 = inf.readLong(1, m, "y1");
        inf.readSpace();
        int x2 = inf.readLong(1, n, "x2");
        inf.readSpace();
        int y2 = inf.readLong(1, m, "y2");
        inf.readEoln();
        int dist = abs(x1 - x2) + abs(y1 - y2);
        ensuref(dist == 1, "expect 2 close points");
        std::pair<int, int> p1 = {x1, y1};
        std::pair<int, int> p2 = {x2, y2};
        if (p1 > p2) {
            swap(p1, p2);
        }
        graph.insert({p1, p2});
    }
    ensuref(graph.size() == k, "unique pairs");
    int l = inf.readInt(1, MAXL, "l");
    inf.readEoln();
    for (int i = 0; i < l; i++) {
        int x = inf.readLong(1, n, "x");
        inf.readSpace();
        int y = inf.readLong(1, m, "y");
        inf.readEoln();
        
    }
    inf.readEof();
}
