#include <iostream>
#include <cmath>

constexpr long long limit = 1000000000;

struct sol {
    long long a, b, c;
};

long long min(long long x, long long y, long long z) {
    if (x <= y && x <= z) {
        return x;
    } else if (y <= x && y <= z) {
        return y;
    } else {
        return z;
    }
}

long long max(long long x, long long y, long long z) {
    if (x >= y && x >= z) {
        return x;
    } else if (y >= x && y >= z) {
        return y;
    } else {
        return z;
    }
}

bool check(long long x, long long y, long long z, long long a, long long b, long long c) {
    if (static_cast<long long>(floorl(sqrtl(a * b))) != x) {
        return false;
    }
    if (static_cast<long long>(floorl(sqrtl(a * c))) != y) {
        return false;
    }
    if (static_cast<long long>(floorl(sqrtl(b * c))) != z) {
        return false;
    }
    return true;
}

sol solve(long long x, long long y, long long z) {
    long long amin = x * y / (z + 1), amax = (x + 1) * (y + 1) / z;
    for (long long a = std::max(1ll, amin); a <= amax; a++) {
        long long
                bmin = x * x / a,
                bmax = (1 + (x + 2) * x) / a;
        long double
                blow = static_cast<long double>(a) * z * z / (y * (y + 2) + 1),
                bhigh = static_cast<long double>(a) * (z * (z + 2) + 1) / y / y;

        long long
                bdown = std::max(bmin, static_cast<long long>(blow)),
                bup = std::min(bmax, static_cast<long long>(bhigh));

        for (long long b = std::max(1ll, bdown); b <= bup; b++) {
            long long
                    cmin = std::max(y * y / a, z * z / b),
                    cmax = std::min((1 + (y + 2) * y) / a, (1 + (z + 2) * z) / b);
            for (long long c = cmin; c <= cmax; c++) {
                if (check(x, y, z, a, b, c)) {
                    return sol{a, b, c};
                }
            }
        }
    }
    return sol{0, 0, 0};
}

int main() {

    int n;
    std::cin >> n;

    for (int i = 0; i < n; i++) {
        long long x, y, z;
        std::cin >> x >> y >> z;

        long long mn = min(x, y, z), mx = max(x, y, z);
        auto res = solve(mn, x + y + z - mn - mx, mx);
        if (z == mx) {
            if (x == mn) {
                std::cout << res.a << ' ' << res.b << ' ' << res.c << '\n';
            } else {
                std::cout << res.a << ' ' << res.c << ' ' << res.b << '\n';
            }
        } else if (y == mx) {
            if (x == mn) {
                std::cout << res.b << ' ' << res.a << ' ' << res.c << '\n';
            } else {
                std::cout << res.c << ' ' << res.a << ' ' << res.b << '\n';
            }
        } else {
            if (y == mn) {
                std::cout << res.b << ' ' << res.c << ' ' << res.a << '\n';
            } else {
                std::cout << res.c << ' ' << res.b << ' ' << res.a << '\n';
            }
        }
    }

}