//
// Created by grifguitar on 25.10.2020.
//

#include <iostream>
#include <cmath>

typedef long long int ll;
typedef long double ld;

using namespace std;

ll g(ll p, ll q) {
    return floorl(sqrtl(p * q));
}

bool check(ll rA, ll rB, ll rC, ll eps, ll x, ll y, ll z) {
    for (ll a = max(rA - eps, 1ll); a <= rA + eps; a++) {
        for (ll b = max(rB - eps, 1ll); b <= rB + eps; b++) {
            for (ll c = max(rC - eps, 1ll); c <= rC + eps; c++) {
                if (g(a, b) == x && g(a, c) == y && g(b, c) == z) {
                    cout << a << " " << b << " " << c << '\n';
                    return true;
                }
            }
        }
    }
    return false;
}

bool check2(ll x, ll y, ll z) {
    ll xx = x * x;
    ll yy = y * y;
    ll zz = z * z;

    for (ll k1 = 0; k1 < 30; k1++) {
        for (ll k2 = 0; k2 < 30; k2++) {
            for (ll k3 = 0; k3 < 30; k3++) {
                ld ab = xx + k1;
                ld ac = yy + k2;
                ld bc = zz + k3;

                ld aa = ab * (ac / bc);
                ld bb = ab * (bc / ac);
                ld cc = ac * (bc / ab);

                ll rA = sqrtl(aa);
                ll rB = sqrtl(bb);
                ll rC = sqrtl(cc);

                if (check(rA, rB, rC, 3, x, y, z)) {
                    return true;
                }
            }
        }
    }
    return false;
}

int main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        ll x, y, z;
        cin >> x >> y >> z;

        if (!check2(x, y, z)) {
            cout << 0 << " " << 0 << " " << 0 << '\n';
        }
    }

    return 0;
}