// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int L = 6, base = 30, mask = (1 << base) - 1;

struct big_int {
	int num[L];
	big_int() {
		memset(num, 0, sizeof num);
	}
	big_int(ll x) {
		memset(num, 0, sizeof num);
		num[0] = x & mask;
		num[1] = x >> base;
	}

	big_int operator*(big_int const& other) const {
		big_int ret;
		for (int i = 0; i < L; ++i) {
			ll carry = 0;
			for (int j = i; j < L; ++j) {
				carry += (ll) num[i] * other.num[j - i];
				carry += ret.num[j];
				ret.num[j] = carry & mask;
				carry >>= base;
			}
		}
		return ret;
	}

	bool operator<(big_int const& other) const {
		for (int i = L - 1; i >= 0; --i) {
			if (num[i] != other.num[i]) {
				return num[i] < other.num[i];
			}
		}
		return false;
	}

	bool operator>(big_int const& other) const {
		return other.operator<(*this);
	}

	bool operator<=(big_int const& other) const {
		return !(operator>(other));
	}
};

ll calc(ll a, ll b) {
	ll ret = sqrt((long double) a * b);
	big_int p = (big_int) a * (big_int) b;
	while ((big_int) ret * (big_int) ret > p) {
		--ret;
	}
	while ((big_int) (ret + 1) * (big_int) (ret + 1) <= p) {
		++ret;
	}

	return ret;
}

pll calc_min_max(ll x, ll a) {
	ll minb = max(1ll, (x * x + a - 1) / a);
	ll maxb = ((x + 1) * (x + 1) - 1) / a;
	return {minb, maxb};
}

vector<ll> solve_sorted(ll x, ll y, ll z) {
	ll mina = max(1ll, x * y / (z + 1));
	ll maxa = (x + 1) * (y + 1) / z;
	// cerr << mina << " " << maxa << endl;
	for (ll a = mina; a <= maxa; ++a) {
		auto [minb, maxb] = calc_min_max(x, a);
		auto [minc, maxc] = calc_min_max(y, a);
		// cerr << minb << " " << maxb << " " << minc << " " << maxc << endl;
		if (minb > maxb || minc > maxc || z < calc(minb, minc) || calc(maxb, maxc) < z) {
			continue;
		}
		// for (ll b = minb; b <= maxb; ++b) {
		// 	for (ll c = minc; c <= maxc; ++c) {
		// 		cerr << calc(b, c) << " ";
		// 	}
		// 	cerr << endl;
		// }
		ll l = minb - 1, r = maxb;
		while (r - l > 1) {
			ll mid = (l + r) / 2;
			if (calc(mid, maxc) < z) {
				l = mid;
			} else {
				r = mid;
			}
		}

		ll b = r;
		if (calc(b, minc) > z) {
			continue;
		}
		l = minc - 1, r = maxc;
		while (r - l > 1) {
			ll mid = (l + r) / 2;
			if (calc(b, mid) < z) {
				l = mid;
			} else {
				r = mid;
			}
		}
		ll c = r;
		assert(calc(b, c) == z);

		return {a, b, c};
	}
	return {0, 0, 0};
}

void solve() {
	int ab, ac, bc;
	cin >> ab >> ac >> bc;
	// cerr << ab << " " << ac << " " << bc << endl;

	vector<int> arr = {ab, ac, bc};
	sort(arr.begin(), arr.end());
	vector<ll> ans = solve_sorted(arr[0], arr[1], arr[2]);
	if (ans[0] == 0) {
		for (auto num : ans) {
			cout << num << " ";
		}
		cout << "\n";
		return;
	}

	sort(ans.begin(), ans.end());
	bool found = false;
	do {
		if (calc(ans[0], ans[1]) == ab && calc(ans[0], ans[2]) == ac && calc(ans[1], ans[2]) == bc) {
			for (auto num : ans) {
				cout << num << " ";
			}
			cout << "\n";
			found = true;
			break;
		}
	} while (next_permutation(ans.begin(), ans.end()));
	assert(found);
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}