// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

struct point {
	int x, y;
	point() {}
	point(int _x, int _y) : x(_x), y(_y) {}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-() const {
		return point(-x, -y);
	}
};

int cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

int dot(point const& p1, point const& p2) {
	return p1.x * p2.x + p1.y * p2.y;
}


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int t = opt<int>(1);
	int minn = opt<int>(2);
	int maxn = opt<int>(3);

	cout << t << "\n";

	for (int tn = 1; tn <= t; ++tn) {
		int n = rnd.next(minn, maxn);
		vector<point> sides;
		for (int x = -20; x <= 20; ++x) {
			for (int y = -20; y <= 20; ++y) {
				if (x == 0 && y == 0) {
					continue;
				}
				if (__gcd(abs(x), abs(y)) == 1) {
					sides.push_back(point(x, y));
				}
			}
		}
		shuffle(sides.begin(), sides.end());
		sides.resize(n - 1);
		sides.push_back(-accumulate(sides.begin(), sides.end(), point(0, 0)));
		sort(sides.begin(), sides.end(), [&](auto& a, auto& b) {
			bool fl1 = a.y > 0 || (a.y == 0 && a.x > 0);
			bool fl2 = b.y > 0 || (b.y == 0 && b.x > 0);
			if (fl1 != fl2) {
				return fl1 < fl2;
			}
			return cross(a, b) > 0;
		});
		bool ok = true;
		for (int i = 0; i < szof(sides); ++i) {
			int next = (i + 1) % szof(sides);
			if (cross(sides[i], sides[next]) == 0) {
				ok = false;
				break;
			}
		}
		if (!ok) {
			--tn;
			continue;
		}
		vector<point> poly = {point(0, 0)};
		for (auto& v : sides) {
			poly.push_back(poly.back() + v);
		}
		poly.pop_back();

		cout << szof(poly) << "\n";
		for (auto p : poly) {
			cout << p.x << " " << p.y << "\n";
		}
	}

	return 0;
}