// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

struct point {
	int x, y;
	point(int _x, int _y) : x(_x), y(_y) {}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	int len2() const {
		return x * x + y * y;
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}

	bool operator!=(point const& other) const {
		return x != other.x || y != other.y;
	}
};

int cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

int dot(point const& p1, point const& p2) {
	return p1.x * p2.x + p1.y * p2.y;
}

const int MAXC = 1000;

vector<point> build_convex_hull(vector<point> arr) {
	point center = *min_element(arr.begin(), arr.end());
	vector<point> ret;
	for (auto p : arr) {
		if (p != center) {
			ret.push_back(p - center);
		}
	}

	swap(ret, arr);
	ret.clear();
	ret.push_back(point(0, 0));

	sort(arr.begin(), arr.end(), [&](auto& p1, auto& p2) {
		int val = cross(p1, p2);
		if (val) {
			return val > 0;
		}
		return p1.len2() < p2.len2();
	});

	for (auto p : arr) {
		while (szof(ret) >= 2 && cross(ret.back() - ret[szof(ret) - 2], p - ret.back()) <= 0) {
			ret.pop_back();
		}
		ret.push_back(p);
	}

	for (auto& p : ret) {
		p = p + center;
	}

	return ret;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int t = opt<int>(1);
	int minq = opt<int>(2);
	int maxq = opt<int>(3);
	string type = opt<string>(4);

	cout << t << "\n";

	for (int tn = 0; tn < t; ++tn) {
		vector<point> points;
		int q = rnd.next(minq, maxq);
		for (int j = 0; j < q; ++j) {
			int x, y;
			while (true) {
				x = rnd.next(-MAXC, MAXC);
				y = rnd.next(-MAXC, MAXC);
				if (type == "square") {
					break;
				}
				if (type == "circle" && x * x + y * y <= MAXC * MAXC) {
					break;
				}
			}
			points.push_back(point(x, y));
		}

		auto hull = build_convex_hull(points);
		rotate(hull.begin(), hull.begin() + rnd.next(0, szof(hull) - 1), hull.end());
		cout << szof(hull) << "\n";
		for (int i = 0; i < szof(hull); ++i) {
			cout << hull[i].x << " " << hull[i].y << "\n";
		}
	}


	return 0;
}