// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

const double PI = atan2(0, -1);

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

struct point {
	int x, y;
	point(int _x, int _y) : x(_x), y(_y) {}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}
};

int cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

int dot(point const& p1, point const& p2) {
	return p1.x * p2.x + p1.y * p2.y;
}

const int MAXT = 1000;
const int MAXN = 100;
const int MAXC = 1000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	int t = inf.readInt(1, MAXT, "t");
	inf.readEoln();

	for (int tn = 1; tn <= t; ++tn) {
		setTestCase(tn);
		int n = inf.readInt(3, MAXN, "n");
		inf.readEoln();

		vector<point> poly;
		for (int i = 0; i < n; ++i) {
			int x = inf.readInt(-MAXC, MAXC, format("x_%d", i + 1));
			inf.readSpace();
			int y = inf.readInt(-MAXC, MAXC, format("y_%d", i + 1));
			inf.readEoln();
			poly.push_back(point(x, y));
		}

		double ang = 0;
		for (int i = 0; i < n; ++i) {
			int next = (i + 1) % n;
			int next2 = (next + 1) % n;
			point v1 = poly[next] - poly[i];
			point v2 = poly[next2] - poly[next];
			ensuref(cross(v1, v2) > 0, "all rotations should be counter-clockwise");
			ang += atan2(cross(v1, v2), dot(v1, v2));	
		}

		ensuref(abs(ang - 2 * PI) < 0.1, "there should be one full counter-clockwise rotation");
	}

	inf.readEof();

	return 0;
}