// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const double eps = 1e-6;

struct point {
	double x, y;

	point(double _x, double _y) : x(_x), y(_y) {}

	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	double len() const {
		return sqrt(x * x + y * y);
	}

	point norm() const {
		double tmp = len();
		return point(x / tmp, y / tmp);
	}

	point ort() const {
		return point(-y, x);
	}
};

double cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

struct line {
	double a, b, c;
	line(point const& p1, point const& p2) {
		a = p2.y - p1.y;
		b = p1.x - p2.x;
		c = -(a * p1.x + b * p1.y);
	}
};

point intersection(line const& l1, line const& l2) {
	double d = l1.a * l2.b - l1.b * l2.a;
	double d1 = -l1.c * l2.b + l1.b * l2.c;
	double d2 = -l1.a * l2.c + l1.c * l2.a;
	return point(d1 / d, d2 / d);
}

void solve() {
	int n;
	cin >> n;
	vector<point> poly;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		poly.push_back(point(x, y));
	}

	if (n == 3) {
		cout << n << "\n";
		for (int i = 0; i < n; ++i) {
			cout << poly[i].x << " " << poly[i].y << "\n";
		}
		return;
	}

	if (n == 4) {
		cout << "3\n";
		if (cross(poly[1] - poly[0], poly[3] - poly[2]) > eps) {
			cout << poly[0].x << " " << poly[0].y << "\n";
			line l1(poly[0], poly[1]);
			line l2(poly[2], poly[3]);
			point p = intersection(l1, l2);
			cout << p.x << " " << p.y << "\n";
			cout << poly[3].x << " " << poly[3].y << "\n";
			return;
		}

		if (cross(poly[3] - poly[0], poly[1] - poly[2]) < -eps) {
			cout << poly[0].x << " " << poly[0].y << "\n";
			cout << poly[1].x << " " << poly[1].y << "\n";
			line l1(poly[0], poly[3]);
			line l2(poly[2], poly[1]);
			point p = intersection(l1, l2);
			cout << p.x << " " << p.y << "\n";
			return;
		}
		line l1(poly[0], poly[1]);
		line l2(poly[0], poly[3]);
		point v = ((poly[1] - poly[0]).norm() + (poly[3] - poly[0]).norm()).ort();
		line l3(poly[2], poly[2] + v);
		cout << poly[0].x << " " << poly[0].y << "\n";
		point a = intersection(l1, l3);
		cout << a.x << " " << a.y << "\n";
		point b = intersection(l2, l3);
		cout << b.x << " " << b.y << "\n";
		return;
	}

	if (n % 2 == 0) {
		for (int i = 0; i < 2; ++i) {
			bool ok = true;
			vector<point> outp;
			for (int j = 0; j < n; j += 2) {
				point v1 = poly[j + 1] - poly[j];
				int next = (j + 2) % n;
				point v2 = poly[next + 1] - poly[next];
				if (cross(v1, v2) < eps) {
					ok = false;
					break;
				}
				outp.push_back(intersection(line(poly[j], poly[j + 1]), line(poly[next], poly[next + 1])));
			}
			if (ok) {
				cout << szof(outp) << "\n";
				for (auto p : outp) {
					cout << p.x << " " << p.y << "\n";
				}
				return;
			}
			rotate(poly.begin(), poly.begin() + 1, poly.end());
		}
		for (int i = 0; i < n; ++i) {
			bool ok = true;
			vector<point> outp = {poly[0], poly[1]};
			for (int j = 1; j < n - 1; j += 2) {
				point v1 = poly[j + 1] - poly[j];
				int next = (j + 2) % n;
				point v2 = poly[(next + 1) % n] - poly[next];
				if (cross(v1, v2) < eps) {
					ok = false;
					break;
				}
				outp.push_back(intersection(line(poly[j], poly[j + 1]), line(poly[next], poly[(next + 1) % n])));
			}
			if (ok) {
				cout << szof(outp) << "\n";
				for (auto p : outp) {
					cout << p.x << " " << p.y << "\n";
				}
				return;
			}
			rotate(poly.begin(), poly.begin() + 1, poly.end());
		}
		assert(false);
	}

	for (int i = 0; i < n; ++i) {
		bool ok = true;
		vector<point> outp = {poly[0]};
		for (int j = 0; j < n - 1; j += 2) {
			point v1 = poly[j + 1] - poly[j];
			int next = (j + 2) % n;
			point v2 = poly[(next + 1) % n] - poly[next];
			if (cross(v1, v2) < eps) {
				ok = false;
				break;
			}
			outp.push_back(intersection(line(poly[j], poly[j + 1]), line(poly[next], poly[(next + 1) % n])));
		}
		if (ok) {
			cout << szof(outp) << "\n";
			for (auto p : outp) {
				cout << p.x << " " << p.y << "\n";
			}
			return;
		}
		rotate(poly.begin(), poly.begin() + 1, poly.end());
	}
	assert(false);
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}