// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

// const ll MOD = 1'000'000'000'000'000'009;
const int P = 239;

// void add(ll& a, ll b) {
// 	a += b;
// 	if (a >= MOD) {
// 		a -= MOD;
// 	}
// }

// ll sum(ll a, ll b) {
// 	add(a, b);
// 	return a;
// }

// ll mult(ll a, ll b) { // works for MOD 8e18
// 	ll k = (ll)((long double)a * b / MOD);
// 	ll r = a * b - MOD * k;
// 	if (r < 0)
// 		r += MOD;
// 	if (r >= MOD)
// 		r -= MOD;
// 	return r;
// }

void add(ull& a, ull b) {
	a += b;
}

ull sum(ull a, ull b) {
	add(a, b);
	return a;
}

ull mult(ull a, ull b) {
	return a * b;
}

const int MAXL = 1e5 + 123;

void solve() {
	vector<ull> pp = {1};
	for (int i = 0; i < MAXL; ++i) {
		pp.push_back(mult(pp.back(), P));
	}

	auto get_hash = [&](vector<ull> arrh, int l, int r) {
		return sum(arrh[r], - mult(arrh[l], pp[r - l]));
	};
	int n;
	cin >> n;
	vector<string> arr;
	vector<vector<ull>> hashes;
	int max_ans = INF;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		max_ans = min(max_ans, szof(s));
		s = s + s;
		arr.push_back(s);
		hashes.push_back({0});
		for (char c : s) {
			hashes[i].push_back(sum(mult(hashes[i].back(), P), c));
		}
	}

	int l = 0, r = max_ans + 1;
	gp_hash_table<ull, int> have;
	while (r - l > 1) {
		have.clear();
		int mid = (l + r) / 2;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < szof(arr[i]) / 2; ++j) {
				ull h = get_hash(hashes[i], j, j + mid);
				// cerr << mid << " " << i << " " << j << " " << h << endl;
				int& val = have[h];
				if (val < i) {
					val = -1;
				} else {
					val = i + 1;
				}
			}
		}

		bool ok = false;
		for (auto p : have) {
			if (p.ss == n) {
				ok = true;
			}
		}
		if (ok) {
			l = mid;
		} else {
			r = mid;
		}
	}

	cout << l << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}