// Checker created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;



int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	int n = inf.readInt();
	int m = inf.readInt();
	int k = inf.readInt();
	int l = inf.readInt();

	set<pii> edges;
	for (int i = 0; i < m; ++i) {
		int a = inf.readInt() - 1;
		int b = inf.readInt() - 1;
		edges.insert({a, b});
		edges.insert({b, a});
	}

	auto check_out = [&](auto& stream) {
		vector<int> res;
		while (!stream.seekEof()) {
			res.push_back(stream.readInt());
			if (szof(res) == 1 && res.back() == -1) {
				return -1;
			}
			stream.ensuref(1 <= res.back() && res.back() <= n, "vertex index is between 1 and %d", n);
			res.back() -= 1;
		}

		int mem_sz = szof(res);
		sort(res.begin(), res.end());
		res.erase(unique(res.begin(), res.end()), res.end());
		stream.ensuref(szof(res) == mem_sz, "all vertex indices should be different");
		
		if (szof(res) == k) {
			bool ok = true;
			for (int i = 0; i < szof(res); ++i) {
				for (int j = i + 1; j < szof(res); ++j) {
					if (edges.count({res[i], res[j]})) {
						ok = false;
						break;
					}
				}
				if (!ok) {
					break;
				}
			}
			if (ok) {
				return 1;
			}
		}

		if (szof(res) == l) {
			bool ok = true;
			for (int i = 0; i < szof(res); ++i) {
				for (int j = i + 1; j < szof(res); ++j) {
					if (!edges.count({res[i], res[j]})) {
						ok = false;
						break;
					}
				}
				if (!ok) {
					break;
				}
			}
			if (ok) {
				return 1;
			}
		}

		stream.quitf(_wa, "output is not a %d-anticlique nor a %d-clique", k, l);
		return -1;
	};

	int jans = check_out(ans);
	int pans = check_out(ouf);

	if (jans == -1 && pans == 1) {
		quitf(_fail, "jury didn't find solution but participant did");
	}

	if (jans == 1 && pans == -1) {
		quitf(_wa, "participant didn't find solution but jury did");
	}

	if (pans == -1) {
		quitf(_ok, "solution doesn't exist");
	}

	quitf(_ok, "participant found solution");

	return 0;
}