#include "testlib.h"
#include "graphs55.h"
#include "graphs54.h"
#include "graphs53.h"
#include <iostream>
#include <unordered_map>
#include <fstream>
#include <unordered_set>
using namespace std;
/*
pair<int, vector<pair<int, int>>> read_graph(istream& in, bool inverted, bool may_shuffle)
{
	string s;
	do
	{
		s = "";
		in >> s;
	} while (!s.empty() && s.back() != '.');
	if (s.empty())
		return pair<int, vector<pair<int, int>>>(0, vector<pair<int, int>>());
	s.pop_back();
	pair<int, vector<pair<int, int>>> ans;
	ans.first = atoi(s.c_str());
	vector<int> perm;
	if (may_shuffle)
		perm = rnd.perm(ans.first);
	else
		for (int i = 0; i < ans.first; ++i)
			perm.push_back(i);
	for (int i = 0; i < ans.first; ++i)
	{
		in >> s;
		for (int j = 0; j < ans.first; ++j)
			if (((s[j] == '0') == inverted) && perm[i] < perm[j])
				ans.second.emplace_back(min(perm[i], perm[j]) + 1, max(perm[i], perm[j]) + 1);
	}
	shuffle(ans.second.begin(), ans.second.end());
	return ans;
}
vector<pair<int, vector<pair<int, int>>>> read_graphs(const string& from, bool must_invert, bool may_invert, bool may_shuffle)
{
	ifstream fin(from);
	vector<pair<int, vector<pair<int, int>>>> ans;
	do
	{
		if (may_invert)
			if (must_invert)
				ans.push_back(read_graph(fin, true, may_shuffle));
			else
				ans.push_back(read_graph(fin, rnd.next(2), may_shuffle));
		else
			ans.push_back(read_graph(fin, false, may_shuffle));

	} while (ans.back().first);
	ans.pop_back();
	return ans;
}
*/
pair<int, vector<pair<int, int>>> read_graph(const vector<vector<bool>>& from, bool inverted, bool may_shuffle)
{
	pair<int, vector<pair<int, int>>> ans;
	ans.first = from.size();
	vector<int> perm;
	if (may_shuffle)
		perm = rnd.perm(ans.first);
	else
		for (int i = 0; i < ans.first; ++i)
			perm.push_back(i);
	for (int i = 0; i < ans.first; ++i)
	{
		for (int j = 0; j < ans.first; ++j)
			if (((from[i][j]) != inverted) && perm[i] < perm[j])
				ans.second.emplace_back(min(perm[i], perm[j]) + 1, max(perm[i], perm[j]) + 1);
	}
	shuffle(ans.second.begin(), ans.second.end());
	return ans;
}
pair<int, vector<pair<int, int>>> read_graph(const vector<vector<bool>>& from, bool must_invert, bool may_invert, bool may_shuffle)
{
	if (may_invert)
		if (must_invert)
			return read_graph(from, true, may_shuffle);
		else
			return read_graph(from, rnd.next(2), may_shuffle);
	else
		return read_graph(from, false, may_shuffle);
}
pair<int, vector<pair<int, int>>> read_and_change_graph(vector<vector<bool>> from, bool must_invert, bool may_invert, bool may_shuffle)
{
	int x = 0, y = 0;
	while (x == y)
	{
		x = rnd.next(from.size());
		y = rnd.next(from.size());
	}
	from[x][y] = !from[x][y];
	from[y][x] = !from[y][x];
	return read_graph(from, must_invert, may_invert, may_shuffle);
}
pair<int, vector<pair<int, int>>> random_graph(const vector<vector<vector<bool>>>& from, bool must_invert, bool may_invert, bool may_shuffle)
{
	return read_graph(rnd.any(from), must_invert, may_invert, may_shuffle);
}
pair<int, vector<pair<int, int>>> random_changed_graph(const vector<vector<vector<bool>>>& from, bool must_invert, bool may_invert, bool may_shuffle)
{
	return read_and_change_graph(rnd.any(from), must_invert, may_invert, may_shuffle);
}
pair<int, vector<pair<int, int>>> random_55_graph()
{
	return random_graph(graphs55, false, true, true);
}
pair<int, vector<pair<int, int>>> random_yes55_graph()
{
	return random_changed_graph(graphs55, false, true, true);
}
pair<int, vector<pair<int, int>>> random_54_graph()
{
	return random_graph(graphs54, false, false, true);
}
pair<int, vector<pair<int, int>>> random_yes54_graph()
{
	return random_changed_graph(graphs54, false, false, true);
}
pair<int, vector<pair<int, int>>> random_45_graph()
{
	return random_graph(graphs54, true, true, true);
}
pair<int, vector<pair<int, int>>> random_yes45_graph()
{
	return random_changed_graph(graphs54, true, true, true);
}
pair<int, vector<pair<int, int>>> random_53_graph()
{
	return random_graph(graphs53, false, false, true);
}
pair<int, vector<pair<int, int>>> random_yes53_graph()
{
	return random_changed_graph(graphs53, false, false, true);
}
pair<int, vector<pair<int, int>>> random_35_graph()
{
	return random_graph(graphs53, true, true, true);
}
pair<int, vector<pair<int, int>>> random_yes35_graph()
{
	return random_changed_graph(graphs53, true, true, true);
}
int main(int argc, char** argv)
{
	registerGen(argc, argv, 1);
	string type = argv[1];
	int N, M, K, L;
	vector<pair<int, int>> edges;
	if (type == "random")
	{
		N = atoi(argv[2]);
		M = atoi(argv[3]);
		K = atoi(argv[4]);
		L = atoi(argv[5]);
		unordered_map<int, unordered_set<int>> edges_set;
		while (edges.size() < M)
		{
			int x = rnd.next(1, N);
			int y = rnd.next(1, N);
			if (x < y)
			{
				if (edges_set[x].count(y) == 0)
				{
					edges_set[x].insert(y);
					edges.emplace_back(x, y);
				}
			}
		}
	}
	else if (type == "no55")
	{
		pair<int, vector<pair<int, int>>> graph = random_55_graph();
		N = graph.first;
		M = graph.second.size();
		K = 5;
		L = 5;
		edges = graph.second;
	}
	else if (type == "yes55")
	{
		pair<int, vector<pair<int, int>>> graph = random_yes55_graph();
		N = graph.first;
		M = graph.second.size();
		K = 5;
		L = 5;
		edges = graph.second;
	}
	else if (type == "no45")
	{
		pair<int, vector<pair<int, int>>> graph = random_45_graph();
		N = graph.first;
		M = graph.second.size();
		K = 4;
		L = 5;
		edges = graph.second;
	}
	else if (type == "yes45")
	{
		pair<int, vector<pair<int, int>>> graph = random_yes45_graph();
		N = graph.first;
		M = graph.second.size();
		K = 4;
		L = 5;
		edges = graph.second;
	}
	else if (type == "no54")
	{
		pair<int, vector<pair<int, int>>> graph = random_54_graph();
		N = graph.first;
		M = graph.second.size();
		K = 5;
		L = 4;
		edges = graph.second;
	}
	else if (type == "yes54")
	{
		pair<int, vector<pair<int, int>>> graph = random_yes54_graph();
		N = graph.first;
		M = graph.second.size();
		K = 5;
		L = 4;
		edges = graph.second;
	}
	else if (type == "no35")
	{
		pair<int, vector<pair<int, int>>> graph = random_35_graph();
		N = graph.first;
		M = graph.second.size();
		K = 4;
		L = 5;
		edges = graph.second;
	}
	else if (type == "yes35")
	{
		pair<int, vector<pair<int, int>>> graph = random_yes35_graph();
		N = graph.first;
		M = graph.second.size();
		K = 4;
		L = 5;
		edges = graph.second;
	}
	else if (type == "no53")
	{
		pair<int, vector<pair<int, int>>> graph = random_53_graph();
		N = graph.first;
		M = graph.second.size();
		K = 5;
		L = 4;
		edges = graph.second;
	}
	else if (type == "yes53")
	{
		pair<int, vector<pair<int, int>>> graph = random_yes53_graph();
		N = graph.first;
		M = graph.second.size();
		K = 5;
		L = 4;
		edges = graph.second;
	}
	else
		quitf(_fail, "insupported test type: %s", type.c_str());
	cout << N << ' ' << M << ' ' << K << ' ' << L << '\n';
	for (int i = 0; i < M; ++i)
		cout << edges[i].first << ' ' << edges[i].second << '\n';
}
