#include "testlib.h"
#include <unordered_map>
using namespace std;
const int MIN_N = 1;
const int MAX_N = 300000;
const int MIN_M = 0;
const int MAX_M = 300000;
const int MIN_K = 1;
const int MAX_K = 5;
const int MIN_L = 1;
const int MAX_L = 5;
int main(int argc, char** argv)
{
	registerValidation(argc, argv);
	int N = inf.readInt(MIN_N, MAX_N, "N");
	inf.readSpace();
	int M = inf.readInt(MIN_M, MAX_M, "M");
	long long max_edges = (long long)N * (N - 1) / 2;
	ensuref(M <= max_edges, "%d = M > N * (N - 1) / 2 = " I64, M, max_edges);
	inf.readSpace();
	int K = inf.readInt(MIN_K, MAX_K, "K");
	ensuref(K <= N, "%d = K > N = %d", K, N);
	inf.readSpace();
	int L = inf.readInt(MIN_L, MAX_L, "L");
	ensuref(L <= N, "%d = L > N = %d", L, N);
	inf.readEoln();
	unordered_map<int, unordered_map<int, int>> edges;
	for (int i = 1; i <= M; ++i)
	{
		int a = inf.readInt(1, N, format("a_%d", i));
		inf.readSpace();
		int b = inf.readInt(1, N, format("b_%d", i));
		ensuref(a < b, "a_%d = %d and b_%d = %d, so a_%d < b_%d doesn't hold", i, a, i, b, i, i);
		int edge_number = edges[a][b];
		ensuref(edge_number == 0, "edge %d is same as egde %d: a_%d = a_%d = %d, b_%d = b_%d = %d",
			i, edge_number, edge_number, i, a, edge_number, i, b);
		edges[a][b] = i;
		inf.readEoln();
	}
	inf.readEof();
}