// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m, k, l;
	cin >> n >> m >> k >> l;
	n = min(n, 50);
	vector<ll> graph(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		if (a < n && b < n) {
			graph[a] |= 1ll << b;
			graph[b] |= 1ll << a;
		}
	}

	vector<int> take;
	function<bool(int)> rec = [&](int v) {
		if (szof(take) == k) {
			bool ok = true;
			ll mask = 0;
			for (int ind : take) {
				mask |= 1ll << ind;
			}
			for (int ind : take) {
				if (graph[ind] & mask) {
					ok = false;
					break;
				}
			}
			if (ok) {
				for (int ind : take) {
					cout << ind + 1 << " ";
				}
				cout << "\n";
				return true;
			}
		}
		if (szof(take) == l) {
			bool ok = true;
			ll mask = 0;
			for (int ind : take) {
				mask |= 1ll << ind;
			}
			for (int ind : take) {
				if ((~graph[ind] & mask) != (1ll << ind)) {
					ok = false;
					break;
				}
			}
			if (ok) {
				for (int ind : take) {
					cout << ind + 1 << " ";
				}
				cout << "\n";
				return true;
			}
		}
		if (szof(take) >= max(k, l)) {
			return false;
		}
		if (v == n) {
			return false;
		}
		take.push_back(v);
		if (rec(v + 1)) {
			return true;
		}
		take.pop_back();
		if (rec(v + 1)) {
			return true;
		}
		return false;
	};

	if (!rec(0)) {
		cout << "-1\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}