// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MOD = 998244353;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int sum(int a, int b) {
	add(a, b);
	return a;
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

int mpow(int a, int b) {
	int ret = 1;
	while (b) {
		if (b & 1) {
			ret = mult(ret, a);
		}
		a = mult(a, a);
		b /= 2;
	}
	return ret;
}

int inv(int num) {
	return mpow(num, MOD - 2);
}

const int bp = 19;
const int bpv = 1 << bp, inv_bpv = inv(bpv);
int arra[bpv], perm[bpv], roots[bpv];

void fft(int arr[]) {
	for (int i = 0; i < bpv; ++i) {
		if (perm[i] > i) {
			swap(arr[i], arr[perm[i]]);
		}
	}

	for (int i = 1, root_shift = bpv / 2; i < bpv; i *= 2, root_shift /= 2) {
		for (int j = 0; j < bpv; j += i * 2) {
			for (int k = 0, root_pos = 0; k < i; ++k, root_pos += root_shift) {
				int val = mult(arr[j + i + k], roots[root_pos]);
				arr[j + i + k] = sum(arr[j + k], MOD - val);
				add(arr[j + k], val);
			}
		}
	}
}

vector<int> calc_vars(int n) {
	fill(arra, arra + bpv, 0);
	for (int i = 0; i < 10; ++i) {
		arra[i] = 1;
	}
	fft(arra);
	for (int i = 0; i < bpv; ++i) {
		arra[i] = mpow(arra[i], n);
	}
	fft(arra);
	reverse(arra + 1, arra + bpv);
	vector<int> ret;
	for (int i = 0; i <= n * 9; ++i) {
		ret.push_back(mult(inv_bpv, arra[i]));
	}
	return ret;
}

void solve() {
	int n;
	cin >> n;
	n /= 2;
	vector<int> vars = calc_vars(n / 2);

	if (n % 2 == 0) {
		int sum = 0;
		for (int num : vars) {
			add(sum, mult(num, num));
		}
		cout << mult(sum, sum) << "\n";
	} else {
		vector<int> vars_p1(szof(vars) + 10);
		for (int i = 0; i < szof(vars); ++i) {
			for (int d = 0; d < 10; ++d) {
				add(vars_p1[i + d], vars[i]);
			}
		}
		int sum1 = 0;
		for (int num : vars) {
			add(sum1, mult(num, num));
		}
		int sum2 = 0;
		for (int num : vars_p1) {
			add(sum2, mult(num, num));
		}
		cout << mult(sum1, sum2) << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int root;
	for (int i = 2; ; ++i) {
		if (mpow(i, bpv / 2) == MOD - 1) {
			root = i;
			break;
		}
	}

	roots[0] = 1;
	for (int i = 1; i < bpv; ++i) {
		roots[i] = mult(roots[i - 1], root);
		perm[i] = (perm[i >> 1] >> 1) | ((i & 1) << (bp - 1));
	}

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}